#include <bits/stdc++.h>

using namespace std;

bool IfPossible(int x, long long int n, long long int a[])
{
    sort(a, a + n);

    for(long long int i = 1; i < n; i++)
    {
        if(abs(a[i] - a[i - 1]) % x == 0)
        {
            return false;
        }
    }

    return true;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;

    cin >> t;

    while(t--)
    {
        long long int n;
        long long int m;
        cin >> n >> m;
        long long int a[n];
        long long int b[m];
        for(int i = 0; i < n; i++)
        {
            cin >> a[i];
        }
        for(int i = 0; i < m; i++)
        {
            cin >> b[i];
        }
        long long int kx = abs(a[1] - a[0]);
        if(IfPossible(kx, m, b))
        {
            cout << kx << "\n";
        }
        else
        {
            cout << 0 << "\n";
        }
        
    }
    
    return 0;
}